package xyz.etztech.javacord.embed

import java.time.OffsetDateTime
import kotlinx.serialization.Contextual
import kotlinx.serialization.Serializable
import kotlinx.serialization.encodeToString
import kotlinx.serialization.json.Json

@Serializable
class Embed {
    private var content = ""
    private var title = ""
    private var description = ""
    private var url = ""
    private var color = 0
    @Contextual
    private var timestamp: OffsetDateTime? = null
    private var footer: Footer? = null
    private var thumbnail: Thumbnail? = null
    private var image: Image? = null
    private var author: Author? = null
    private var fields: MutableList<Field>? = mutableListOf()
    fun content(content: String): Embed {
        this.content = content
        return this
    }

    fun title(title: String): Embed {
        this.title = title
        return this
    }

    fun description(description: String): Embed {
        this.description = description
        return this
    }

    fun url(url: String): Embed {
        this.url = url
        return this
    }

    fun color(color: Int): Embed {
        this.color = color
        return this
    }

    fun timestamp(timestamp: OffsetDateTime?): Embed {
        this.timestamp = timestamp
        return this
    }

    fun footer(footer: Footer?): Embed {
        this.footer = footer
        return this
    }

    fun thumbnail(thumbnail: Thumbnail?): Embed {
        this.thumbnail = thumbnail
        return this
    }

    fun image(image: Image?): Embed {
        this.image = image
        return this
    }

    fun author(author: Author?): Embed {
        this.author = author
        return this
    }

    fun fields(fields: MutableList<Field>): Embed {
        this.fields = fields
        return this
    }

    fun addField(field: Field): Embed {
        fields?.add(field)
        return this
    }

    override fun toString(): String {
        return Json.encodeToString(this)
    }
}