package xyz.etztech.javacord.embed

import org.junit.jupiter.api.Assertions
import org.junit.jupiter.api.Test

class EmbedTest {
    @Test
    fun testEmbed() {
        val embed =
            Embed().color(0x151515)
                .author(Author("Etzelia", "https://etzel.ia", "", ""))
                .title("Test \"Title\"")
                .description("Test Description")
                .fields(
                    mutableListOf(
                        Field("Field1", "foo"),
                        Field("Field2", "bar"),
                        Field("Field3", "baz", true)
                    )
                )
        val expected =
            "{\"title\":\"Test \\\"Title\\\"\",\"description\":\"Test Description\",\"color\"" +
                ":1381653,\"author\":{\"name\":\"Etzelia\",\"url\":\"https://etzel.ia\",\"iconURL" +
                "\":\"\",\"proxyIconURL\":\"\"},\"fields\":[{\"name\":\"Field1\",\"value\":\"foo" +
                "\",\"inline\":false},{\"name\":\"Field2\",\"value\":\"bar\",\"inline\":false},{" +
                "\"name\":\"Field3\",\"value\":\"baz\",\"inline\":true}]}"
        Assertions.assertEquals(expected, embed.toString())
    }
}